/**
 * findAndReplaceDOMText v 0.4.6
 * @author James Padolsey http://james.padolsey.com
 * @license http://unlicense.org/UNLICENSE
 *
 * Matches the text of a DOM node against a regular expression
 * and replaces each match (or node-separated portions of the match)
 * in the specified element.
 */
!function(e,n){"object"==typeof module&&module.exports?module.exports=n():"function"==typeof define&&define.amd?define(n):e.findAndReplaceDOMText=n()}(this,(function(){var e="retain",n=document,t={}.hasOwnProperty;function i(){return r.apply(null,arguments)||o.apply(null,arguments)}function r(e,n,t,r,d){if(n&&!n.nodeType&&arguments.length<=2)return!1;var a,s="function"==typeof t;s&&(a=t,t=function(e,n){return a(e.text,n.startIndex)});var c=o(n,{find:e,wrap:s?null:t,replace:s?t:"$"+(r||"&"),prepMatch:function(e,n){if(!e[0])throw"findAndReplaceDOMText cannot handle zero-length matches";if(r>0){var t=e[r];e.index+=e[0].indexOf(t),e[0]=t}return e.endIndex=e.index+e[0].length,e.startIndex=e.index,e.index=n,e},filterElements:d});return i.revert=function(){return c.revert()},!0}function o(e,n){return new d(e,n)}function d(n,r){var o=r.preset&&i.PRESETS[r.preset];if(r.portionMode=r.portionMode||e,o)for(var d in o)t.call(o,d)&&!t.call(r,d)&&(r[d]=o[d]);this.node=n,this.options=r,this.prepMatch=r.prepMatch||this.prepMatch,this.reverts=[],this.matches=this.search(),this.matches.length&&this.processMatches()}return i.NON_PROSE_ELEMENTS={br:1,hr:1,script:1,style:1,img:1,video:1,audio:1,canvas:1,svg:1,map:1,object:1,input:1,textarea:1,select:1,option:1,optgroup:1,button:1},i.NON_CONTIGUOUS_PROSE_ELEMENTS={address:1,article:1,aside:1,blockquote:1,dd:1,div:1,dl:1,fieldset:1,figcaption:1,figure:1,footer:1,form:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,header:1,hgroup:1,hr:1,main:1,nav:1,noscript:1,ol:1,output:1,p:1,pre:1,section:1,ul:1,br:1,li:1,summary:1,dt:1,details:1,rp:1,rt:1,rtc:1,script:1,style:1,img:1,video:1,audio:1,canvas:1,svg:1,map:1,object:1,input:1,textarea:1,select:1,option:1,optgroup:1,button:1,table:1,tbody:1,thead:1,th:1,tr:1,td:1,caption:1,col:1,tfoot:1,colgroup:1},i.NON_INLINE_PROSE=function(e){return t.call(i.NON_CONTIGUOUS_PROSE_ELEMENTS,e.nodeName.toLowerCase())},i.PRESETS={prose:{forceContext:i.NON_INLINE_PROSE,filterElements:function(e){return!t.call(i.NON_PROSE_ELEMENTS,e.nodeName.toLowerCase())}}},i.Finder=d,d.prototype={search:function(){var e,n=0,t=0,i=this.options.find,r=this.getAggregateText(),o=[],d=this;return i="string"==typeof i?RegExp(String(i).replace(/([.*+?^=!:${}()|[\]\/\\])/g,"\\$1"),"g"):i,function r(a){for(var s=0,c=a.length;s<c;++s){var l=a[s];if("string"==typeof l){if(i.global)for(;e=i.exec(l);)o.push(d.prepMatch(e,n++,t));else(e=l.match(i))&&o.push(d.prepMatch(e,0,t));t+=l.length}else r(l)}}(r),o},prepMatch:function(e,n,t){if(!e[0])throw new Error("findAndReplaceDOMText cannot handle zero-length matches");return e.endIndex=t+e.index+e[0].length,e.startIndex=t+e.index,e.index=n,e},getAggregateText:function(){var e=this.options.filterElements,n=this.options.forceContext;return function t(i){if(i.nodeType===Node.TEXT_NODE)return[i.data];if(e&&!e(i))return[];var r=[""];var o=0;if(i=i.firstChild)do{if(i.nodeType!==Node.TEXT_NODE){var d=t(i);n&&i.nodeType===Node.ELEMENT_NODE&&(!0===n||n(i))?(r[++o]=d,r[++o]=""):("string"==typeof d[0]&&(r[o]+=d.shift()),d.length&&(r[++o]=d,r[++o]=""))}else r[o]+=i.data}while(i=i.nextSibling);return r}(this.node)},processMatches:function(){var e,n,t,i=this.matches,r=this.node,o=this.options.filterElements,d=[],a=r,s=i.shift(),c=0,l=0,p=[r];e:for(;;){if(a.nodeType===Node.TEXT_NODE&&(!n&&a.length+c>=s.endIndex?n={node:a,index:l++,text:a.data.substring(s.startIndex-c,s.endIndex-c),indexInMatch:0===c?0:c-s.startIndex,indexInNode:s.startIndex-c,endIndexInNode:s.endIndex-c,isEnd:!0}:e&&d.push({node:a,index:l++,text:a.data,indexInMatch:c-s.startIndex,indexInNode:0}),!e&&a.length+c>s.startIndex&&(e={node:a,index:l++,indexInMatch:0,indexInNode:s.startIndex-c,endIndexInNode:s.endIndex-c,text:a.data.substring(s.startIndex-c,s.endIndex-c)}),c+=a.data.length),t=a.nodeType===Node.ELEMENT_NODE&&o&&!o(a),e&&n){if(a=this.replaceMatch(s,e,d,n),c-=n.node.data.length-n.endIndexInNode,e=null,n=null,d=[],l=0,!(s=i.shift()))break}else if(!t&&(a.firstChild||a.nextSibling)){a.firstChild?(p.push(a),a=a.firstChild):a=a.nextSibling;continue}for(;;){if(a.nextSibling){a=a.nextSibling;break}if((a=p.pop())===r)break e}}},revert:function(){for(var e=this.reverts.length;e--;)this.reverts[e]();this.reverts=[]},prepareReplacementString:function(e,n,t){var i=this.options.portionMode;return"first"===i&&n.indexInMatch>0?"":(e=e.replace(/\$(\d+|&|`|')/g,(function(e,n){var i;switch(n){case"&":i=t[0];break;case"`":i=t.input.substring(0,t.startIndex);break;case"'":i=t.input.substring(t.endIndex);break;default:i=t[+n]||""}return i})),"first"===i?e:n.isEnd?e.substring(n.indexInMatch):e.substring(n.indexInMatch,n.indexInMatch+n.text.length))},getPortionReplacementNode:function(e,t){var i=this.options.replace||"$&",r=this.options.wrap,o=this.options.wrapClass;if(r&&r.nodeType){var d=n.createElement("div");d.innerHTML=r.outerHTML||(new XMLSerializer).serializeToString(r),r=d.firstChild}if("function"==typeof i)return(i=i(e,t))&&i.nodeType?i:n.createTextNode(String(i));var a="string"==typeof r?n.createElement(r):r;return a&&o&&(a.className=o),(i=n.createTextNode(this.prepareReplacementString(i,e,t))).data&&a?(a.appendChild(i),a):i},replaceMatch:function(e,t,i,r){var o,d,a=t.node,s=r.node;if(a===s){var c=a;t.indexInNode>0&&(o=n.createTextNode(c.data.substring(0,t.indexInNode)),c.parentNode.insertBefore(o,c));var l=this.getPortionReplacementNode(r,e);return c.parentNode.insertBefore(l,c),r.endIndexInNode<c.length&&(d=n.createTextNode(c.data.substring(r.endIndexInNode)),c.parentNode.insertBefore(d,c)),c.parentNode.removeChild(c),this.reverts.push((function(){o===l.previousSibling&&o.parentNode.removeChild(o),d===l.nextSibling&&d.parentNode.removeChild(d),l.parentNode.replaceChild(c,l)})),l}o=n.createTextNode(a.data.substring(0,t.indexInNode)),d=n.createTextNode(s.data.substring(r.endIndexInNode));for(var p=this.getPortionReplacementNode(t,e),h=[],u=0,f=i.length;u<f;++u){var x=i[u],g=this.getPortionReplacementNode(x,e);x.node.parentNode.replaceChild(g,x.node),this.reverts.push(function(e,n){return function(){n.parentNode.replaceChild(e.node,n)}}(x,g)),h.push(g)}var m=this.getPortionReplacementNode(r,e);return a.parentNode.insertBefore(o,a),a.parentNode.insertBefore(p,a),a.parentNode.removeChild(a),s.parentNode.insertBefore(m,s),s.parentNode.insertBefore(d,s),s.parentNode.removeChild(s),this.reverts.push((function(){o.parentNode.removeChild(o),p.parentNode.replaceChild(a,p),d.parentNode.removeChild(d),m.parentNode.replaceChild(s,m)})),m}},i}));const findInNw={initialized:!1,lastSearched:"",create:{css:".find-in-nw-search-box{position:fixed;top:10px;right:10px;display:none;width:300px;background:#f1f1f1;border:1px solid #c1c1c1;border-radius:7px;margin:0px;padding:0px;box-shadow:1px 3px 9px rgba(0,0,0,.6)}.find-in-nw-search-box-visible{display:flex}.find-in-nw-input{flex-grow:1;background:transparent;border:0px;margin:0px;padding:0px 0px 0px 3px;font-size:16px}.find-in-nw-close{width:32px;background:transparent;border:0px;margin:0px;padding:0px;font-size:32px;opacity:.5}.find-in-nw-close:hover{opacity:1}.find-in-nw-search-box,.find-in-nw-input,.find-in-nw-count,.find-in-nw-close{height:32px;color:#000;font-family:sans-serif;line-height:32px;vertical-align:top}.find-in-nw-input:focus,.find-in-nw-close:focus{opacity:1;outline:none}.find-in-nw-token{background-color:#ff0}",style:function(){const e=document.createElement("style");return e.setAttribute("id","find-in-nw-style"),e.innerText=this.css,e},container:function(){const e=document.createElement("div");return e.setAttribute("id","find-in-nw-search-box"),e.setAttribute("class","find-in-nw-search-box"),e},input:function(){const e=document.createElement("input");return e.setAttribute("id","find-in-nw-input"),e.setAttribute("class","find-in-nw-input"),e.setAttribute("placeholder","Find"),e},count:function(){const e=document.createElement("span");return e.setAttribute("id","find-in-nw-count"),e.setAttribute("class","find-in-nw-count"),e.innerHTML="0",e},close:function(){const e=document.createElement("button");return e.setAttribute("id","find-in-nw-close"),e.setAttribute("class","find-in-nw-close"),e.innerHTML="&times;",e},composeSearchBox:function(){const e=this.container(),n=this.input(),t=this.count(),i=this.close();return e.appendChild(n),e.appendChild(t),e.appendChild(i),e}},closeButtonClicked:function(){document.getElementById("find-in-nw-close").addEventListener("click",function(e){e.preventDefault(),this.hideSearchBox()}.bind(this))},inputChanged:function(){document.getElementById("find-in-nw-input").addEventListener("input",function(e){e.preventDefault();const n=e.target.value;n&&n!==this.lastSearched?this.search(n):n||this.clearTokens()}.bind(this))},eventBinding:function(){this.closeButtonClicked(),this.inputChanged()},keyBindings:function(){document.onkeydown=function(e){return e.ctrlKey&&70===e.keyCode?(e.preventDefault(),this.showSearchBox(),!1):27===e.keyCode?(e.preventDefault(),this.hideSearchBox(),!1):void 0}.bind(this)},showSearchBox:function(){const e=document.getElementById("find-in-nw-search-box"),n=document.getElementById("find-in-nw-input");e.classList.add("find-in-nw-search-box-visible"),n.focus()},hideSearchBox:function(){const e=document.getElementById("find-in-nw-search-box"),n=document.getElementById("find-in-nw-input");e.classList.remove("find-in-nw-search-box-visible"),document.body.focus(),n.value="",this.clearTokens()},getElementsToSearch:function(){const e=[];for(let n=0;n<document.body.children.length;n++){let t=document.body.children[n];"style"!==t.tagName.toLowerCase()&&"script"!==t.tagName.toLowerCase()&&e.push(t)}return e},updateCount:function(){const e=document.getElementsByClassName("find-in-nw-token");document.getElementById("find-in-nw-count").innerHTML=e.length.toLocaleString()},clearTokens:function(){const e=document.getElementsByClassName("find-in-nw-token");let n=[];for(let t=0;t<e.length;t++)n.push(e[t].parentNode);for(n=Array.from(new Set(n));e.length;)e[0].replaceWith(...e[0].childNodes);n.forEach((function(e){e.normalize()})),this.lastSearched="",this.updateCount()},search:function(e){this.clearTokens(),this.getElementsToSearch().forEach((function(n){window.findAndReplaceDOMText(n,{find:e,wrap:"mark",wrapClass:"find-in-nw-token"})})),this.lastSearched=e,this.updateCount()},initialize:function(){if(!this.initialized){const e=this.create.style(),n=this.create.composeSearchBox();document.body.append(n),document.body.append(e),this.keyBindings(),this.eventBinding(),this.initialized=!0}}};
